unit u_main;

// Purpose: Main form with control- status and data display functions

{$mode objfpc}{$H+}
// Collapse all procedures:  alt shift 1

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, StdCtrls, Buttons;

type { TFrmMain }

  TFrmMain = class(TForm)
    ButtChangeParameters: TButton;
    ButtClear: TButton;
    ButtClearDidResetMyself: TButton;
    ButtEnterComment: TButton;
    ButtNewFileName: TButton;
    ButtOtherHalf: TButton;
    ButtResetArduino: TButton;
    ButtRefresh: TButton;
    ButtReSync: TButton;
    ButtSetDefaultParameters: TButton;
    CbxChargeBattery: TCheckBox;
    CbxPlotRim_1: TCheckBox;
    CbxPlotRim_2: TCheckBox;
    CbxHoldPower: TCheckBox;
    CbxForceMaximumDriveWidth: TCheckBox;
    CbxForceMinimumDriveWidth: TCheckBox;
    CbxEnableDrive: TCheckBox;
    CbxEnlarge: TCheckBox;
    CbxPersistence: TCheckBox;
    CbxShowAC: TCheckBox;
    CbxShowARim: TCheckBox;
    CbxShowPrecessionAngle: TCheckBox;
    CbxShowShortAxis: TCheckBox;
    CbxShowTdiff: TCheckBox;
    CbxShowWidthDrive: TCheckBox;
    CbxTalk: TCheckBox;
    CbxCalibrateHallSensors: TCheckBox;
    CbxMemo: TCheckBox;
    GbxParameters: TGroupBox;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    GbxCommunication: TGroupBox;
    GbxHallSensors: TGroupBox;
    GbxStatus: TGroupBox;
    GbxGeneral: TGroupBox;
    GbxTimeDisplay: TGroupBox;
    GbxCompass: TGroupBox;
    Label100: TLabel;
    Label101: TLabel;
    Label102: TLabel;
    Label103: TLabel;
    Label104: TLabel;
    Label14: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label27: TLabel;
    Label39: TLabel;
    Label40: TLabel;
    Label41: TLabel;
    Label42: TLabel;
    Label43: TLabel;
    Label44: TLabel;
    Label45: TLabel;
    Label46: TLabel;
    Label48: TLabel;
    Label49: TLabel;
    Label50: TLabel;
    Label52: TLabel;
    Label53: TLabel;
    Label54: TLabel;
    Label55: TLabel;
    Label59: TLabel;
    Label60: TLabel;
    Label61: TLabel;
    Label62: TLabel;
    Label63: TLabel;
    Label64: TLabel;
    Label65: TLabel;
    Label67: TLabel;
    Label68: TLabel;
    Label69: TLabel;
    Label70: TLabel;
    Label71: TLabel;
    Label72: TLabel;
    Label73: TLabel;
    Label74: TLabel;
    Label75: TLabel;
    Label76: TLabel;
    Label77: TLabel;
    Label78: TLabel;
    Label79: TLabel;
    Label82: TLabel;
    Label83: TLabel;
    Label84: TLabel;
    Label85: TLabel;
    Label86: TLabel;
    Label87: TLabel;
    Label88: TLabel;
    Label89: TLabel;
    Label90: TLabel;
    Label91: TLabel;
    LblStatusSeenRim_2: TLabel;
    LblStatusDidReSyncMySelf: TLabel;
    LblStatusMaxDriveLevel: TLabel;
    LblStatusMinDriveLevel: TLabel;
    LblStatusDidResetMyself: TLabel;
    LblStatusMissedRim_2: TLabel;
    LblStatusBit14: TLabel;
    LblStatusHalfSwing: TLabel;
    LblStatusCenterMissed: TLabel;
    LblStatusCenterSeen: TLabel;
    LblStatusHaveSync: TLabel;
    LblStatusGeneralError: TLabel;
    LblStatusMissedRim_1: TLabel;
    LblStatusBit11: TLabel;
    LblStatusSeenRim_1: TLabel;
    LblStatusBit10: TLabel;
    LinGraph: TPaintBox;
    TbxAdcCenter: TEdit;
    TbxAdcRim: TEdit;
    TbxAmplitudeFromRim_mm: TEdit;
    TbxCompassScale: TEdit;
    TbxComment: TEdit;
    TbxEllipseRatio_Percent: TEdit;
    TbxPeakRim_2: TEdit;
    TbxAverageFactor_Percent: TEdit;
    TbxSetPoint_Amplitude_mm1: TEdit;
    TbxV24Raw: TEdit;
    TbxBatteryCurrent_mA: TEdit;
    TbxBatteryVoltage_Volt: TEdit;
    TbxV24Cal: TEdit;
    TbxRimCoilRadius_mm: TEdit;
    TbxSetPoint_Amplitude_mm: TEdit;
    TbxTMinDriveWidth: TEdit;
    TbxFarestNS: TEdit;
    TbxPrecessionAngle: TEdit;
    TbxFarestEW: TEdit;
    TbxStatus: TEdit;
    TbxArduinoIP: TEdit;
    TbxCurrentTime: TEdit;
    TbxEast: TEdit;
    TbxEllipseLongAxis: TEdit;
    TbxEllipseShortAxis: TEdit;
    TbxFirmwareVersion: TEdit;
    TbxInMessage: TEdit;
    TbxInMessageCount: TEdit;
    TbxInMessageLength: TEdit;
    TbxLastCleared: TEdit;
    TbxLogFileName: TEdit;
    TbxNorth: TEdit;
    TbxOutMessage: TEdit;
    TbxOutMessageCount: TEdit;
    TbxOutMessageLength: TEdit;
    TbxPeakCenter: TEdit;
    TbxPeakRim_1: TEdit;
    TbxPosEW: TEdit;
    TbxPosNS: TEdit;
    TbxSouth: TEdit;
    TbxTMissedRim_2: TEdit;
    TbxTPassRim_2: TEdit;
    TbxTStartLookForRim_1: TEdit;
    Memo: TMemo;
    TbxTStartLookForCenter: TEdit;
    TbxTDrivePosition: TEdit;
    TbxTMissedCenter: TEdit;
    TbxTMissedRim_1: TEdit;
    TbxTPassCenter: TEdit;
    TbxTPassRim_1: TEdit;
    TbxMaxDriveWidth: TEdit;
    TbxTStartLookForRim_2: TEdit;
    TbxWest: TEdit;
    TimerSend: TTimer;
    procedure ButtChangeParametersClick (Sender: TObject);
    procedure ButtClearClick (Sender: TObject);
    procedure ButtClearDidResetMyselfClick(Sender: TObject);
    procedure ButtEnterCommentClick (Sender: TObject);
    procedure ButtNewFileNameClick (Sender: TObject);
    procedure ButtOtherHalfClick(Sender: TObject);
    procedure ButtRefreshClick (Sender: TObject);
    procedure ButtResetArduinoClick (Sender: TObject);
    procedure ButtReSyncClick (Sender: TObject);
    procedure ButtSetDefaultParametersClick (Sender: TObject);
    procedure CbxCalibrateHallSensorsChange (Sender: TObject);
    procedure CbxChargeBatteryChange(Sender: TObject);
    procedure CbxEnableDriveChange (Sender: TObject);
    procedure CbxForceMaximumDriveWidthChange (Sender: TObject);
    procedure CbxForceMinimumDriveWidthChange (Sender: TObject);
    procedure CbxHoldPowerChange(Sender: TObject);
    procedure CbxPlotRim_1Change(Sender: TObject);
    procedure CbxPlotRim_2Change(Sender: TObject);
    procedure CbxMemoChange(Sender: TObject);
    procedure CbxTalkChange (Sender: TObject);
    procedure CbxEnlargeChange (Sender: TObject);
    procedure CbxPersistenceChange (Sender: TObject);
    procedure TimerSendTimer (Sender: TObject);
    procedure FormDestroy (Sender: TObject);
    procedure FormCreate (Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

const
  VERSIONSTRING ='v 2023-09-04';
  VERSIONNUMBER = 30904;
  TITLE = 'Logging Foucault Pendulum ';

var
  ParameterFilename: string;
var
  FrmMain: TFrmMain;

  ExeDir, LoggingPath, LogFileName, EventLogFileName, LogStr: shortstring;
  Talk, ForceReSync, InvertHalfSwing, PlotRim_1, PlotRim_2,
  ForceMinimalDriveWidth, ForceMaximalDriveWidth,
  UseMinimalDriveWidth, UseMaximalDriveWidth,
  Persistence, Enlarge, AutoZero, CalibrateHallSensors,
  HoldPower, ChargeBattery, ResetArduino,
  StoreInEEPROM, ClearDidResetMyself, ShowOnMemo: boolean;
  TStartLookForCenter,
  TMissedCenter,
  TStartLookForRim_1,
  TMissedRim_1,
  TStartLookForRim_2,
  TMissedRim_2,
  RimCoilRadius_mm,
  SetPoint_Amplitude_mm,
  TMidDrive: word;
  TMaxDriveWidth, TMinDriveWidth: byte;
  V24Cal: real;

implementation
{$R *.lfm}

uses u_logging, u_timestrings, u_messages, u_lingraph, u_numstrings, u_compass;

// ***** Manipulate Parameters ***************
procedure WriteParametersToTextBoxes;
begin
  with Frmmain do
  begin
    TbxTStartLookForCenter.text:=   format ('%6d',[TStartLookForCenter]);
    TbxTMissedCenter.text:=         format ('%6d',[TMissedCenter]);
    TbxTStartLookForRim_1.text:=    format ('%6d',[TStartLookForRim_1]);
    TbxTMissedRim_1.text:=          format ('%6d',[TMissedRim_1]);
    TbxTStartLookForRim_2.text:=    format ('%6d',[TStartLookForRim_2]);
    TbxTMissedRim_2.text:=          format ('%6d',[TMissedRim_2]);
    TbxTMinDriveWidth.text:=        format ('%4d',[TMinDriveWidth]);
    TbxMaxDriveWidth.text:=         format ('%4d',[TmaxDriveWidth]);
    TbxTDrivePosition.text:=        format ('%6d',[TMidDrive]);
    TbxRimCoilRadius_mm.text:=      format ('%4d',[RimCoilRadius_mm]);
    TbxSetPoint_Amplitude_mm.text:= format ('%4d',[SetPoint_Amplitude_mm]);
  end;
end;

procedure ReadParametersFromTextBoxes;
begin
  with FrmMain do
  begin
    TStartLookForCenter:=   Fival (TbxTStartLookForCenter.text);
    TMissedCenter:=         Fival (TbxTMissedCenter.text);
    TStartLookForRim_1:=    Fival (TbxTStartLookForRim_1.text);
    TMissedRim_1:=          Fival (TbxTMissedRim_1.text);
    TStartLookForRim_2:=    Fival (TbxTStartLookForRim_2.text);
    TMissedRim_2:=          Fival (TbxTMissedRim_2.text);
    TMinDriveWidth:=        FIval (TbxTMinDriveWidth.text);
    TMaxDriveWidth:=        FIval (TbxMaxDriveWidth.text);
    TMidDrive:=             Fival (TbxTDrivePosition.text);
    RimCoilRadius_mm:=      FIval (TbxRimCoilRadius_mm.text);
    SetPoint_Amplitude_mm:= FIval (TbxSetPoint_Amplitude_mm.text);
  end;
end;

procedure WriteParametersToFile;
var
  ParameterFile: text;
begin
  assign (ParameterFile, ParameterFileName);
  rewrite (ParameterFile);
  writeln (ParameterFile, TStartLookForCenter);
  writeln (ParameterFile, TMissedCenter);
  writeln (ParameterFile, TStartLookForRim_1);
  writeln (ParameterFile, TMissedRim_1);
  writeln (ParameterFile, TStartLookForRim_2);
  writeln (ParameterFile, TMissedRim_2);
  writeln (ParameterFile, TMinDriveWidth);
  writeln (ParameterFile, TMaxDriveWidth);
  writeln (ParameterFile, TMidDrive);
  writeln (ParameterFile, RimCoilRadius_mm);
  writeln (ParameterFile, SetPoint_Amplitude_mm);
  Close (ParameterFile);
end;

procedure ReadParametersFromFile;
var
  ParameterFile: text;
begin
  if not FileExists (ParameterFileName) then exit;
  assign (ParameterFile, ParameterFileName);
  reset (ParameterFile);
  with FrmMain do
  begin
    readln (ParameterFile, TStartLookForCenter);
    readln (ParameterFile, TMissedCenter);
    readln (ParameterFile, TStartLookForRim_1);
    readln (ParameterFile, TMissedRim_1);
    readln (ParameterFile, TStartLookForRim_2);
    readln (ParameterFile, TMissedRim_2);
    readln (ParameterFile, TMinDriveWidth);
    readln (ParameterFile, TMaxDriveWidth);
    readln (ParameterFile, TMidDrive);
    readln (ParameterFile, RimCoilRadius_mm);
    readln (ParameterFile, SetPoint_Amplitude_mm);
  end;
  Close (ParameterFile);
  WriteParametersToTextBoxes;
end;

procedure TFrmMain.ButtSetDefaultParametersClick (Sender: TObject);
begin
  TStartLookForCenter:= 18000;
  TMissedCenter:=       22000;
  TStartLookForRim_1:=   4000;
  TMissedRim_1:=         5500;
  TStartLookForRim_2:=  15000;
  TMissedRim_2:=        17000;
  TMinDriveWidth:=         10;
  TMaxDriveWidth:=         40;
  TMidDrive:=             700;
  RimCoilRadius_mm:=      150;
  SetPoint_Amplitude_mm:= 230;
  WriteParametersToTextBoxes;
  WriteParametersToFile;
end;

// *** GroupBox Parameters **********
procedure TFrmMain.CbxForceMaximumDriveWidthChange (Sender: TObject);
begin
  ForceMaximalDriveWidth:= (CbxForceMaximumDriveWidth.checked);
  CbxForceMinimumDriveWidth.checked:= false;
end;

procedure TFrmMain.CbxForceMinimumDriveWidthChange (Sender: TObject);
begin
  ForceMinimalDriveWidth:= (CbxForceMinimumDriveWidth.checked);
  CbxForceMaximumDriveWidth.checked:= false;
end;

procedure TFrmMain.ButtChangeParametersClick (Sender: TObject);
// Used after a manual change in a textbox
begin
  ReadParametersFromTextBoxes;
  WriteParametersToFile;
  StoreInEEPROM:= true;  // Signal to Arduino
  AddToLog ('** Changed Parameters');
  WriteParametersToEventLog;
end;

procedure TFrmMain.ButtReSyncClick (Sender: TObject);
begin
  ForceResync:= true;
  AddToLog ('** ForceResync');
  AddToEventLog ('ForceResync');
end;

procedure TFrmMain.CbxEnableDriveChange (Sender: TObject);
begin
  if CbxEnableDrive.checked then
  begin
    AddToLog ('** Drive Enabled');
    AddtoEventLog ('Drive Enabled');
  end
  else
  begin
    AddToLog ('** Drive Disabled');
    AddtoEventLog ('Drive Disabled');
  end;
end;

procedure TFrmMain.CbxPlotRim_1Change(Sender: TObject);
begin
  PlotRim_1:= CbxPlotRim_1.checked;
end;

procedure TFrmMain.CbxPlotRim_2Change(Sender: TObject);
begin
  PlotRim_2:= CbxPlotRim_2.checked;
end;

procedure TFrmMain.CbxMemoChange(Sender: TObject);
begin
  ShowOnMemo:= CbxMemo.Checked;
end;

// *** GroupBox Communication **********
procedure TFrmMain.CbxTalkChange (Sender: TObject);
begin
  Compass.Init (FrmMain, 510, 3, 330);
  if CbxTalk.Checked then
    StartTalking
  else
    StopTalking;
end;

procedure TFrmMain.ButtResetArduinoClick (Sender: TObject);
begin
  ResetArduino:= true;
end;

procedure TFrmMain.ButtClearDidResetMyselfClick(Sender: TObject);
begin
  ClearDidResetMyself:= true;
end;

// *** GroupBox Time Display **********
procedure TFrmMain.ButtRefreshClick (Sender: TObject);
begin
  LinGraph_Init;
  LinGraph_Refresh;
end;

// *** GroupBox Compass **********
procedure TFrmMain.ButtClearClick (Sender: TObject);
begin
  TbxLastCleared.text:= MyTime_hms;
  Compass.Init (FrmMain, 510, 3, 330);
  AddToEventLog ('ClearCompass Click');
end;

procedure TFrmMain.CbxPersistenceChange (Sender: TObject);
begin
  Persistence:= CbxPersistence.Checked;
  ButtClearClick(Sender);
end;

procedure TFrmMain.CbxEnlargeChange (Sender: TObject);
begin
  Enlarge:= CbxEnlarge.checked;
end;

// *** GroupBox Hall Sensors **********
procedure TFrmMain.CbxCalibrateHallSensorsChange (Sender: TObject);
begin
  CalibrateHallSensors:= CbxCalibrateHallSensors.Checked;
end;

// *** GroupBox General **********
procedure TFrmMain.ButtEnterCommentClick (Sender: TObject);
begin
  AddToLog('** ' + TbxComment.Text);
  AddToEventLog (TbxComment.Text);
end;

procedure TFrmMain.ButtNewFileNameClick(Sender: TObject);
begin
  NewLogFileNames;
end;

procedure TFrmMain.ButtOtherHalfClick(Sender: TObject);
begin
  InvertHalfSwing:= true;
end;

// *** GroupBox Power **********
procedure TFrmMain.CbxChargeBatteryChange(Sender: TObject);
begin
  ChargeBattery:= CbxChargeBattery.checked;
end;

procedure TFrmMain.CbxHoldPowerChange(Sender: TObject);
begin
  HoldPower:= CbxHoldPower.checked;
end;

// *** FrmMain **********
procedure TFrmMain.TimerSendTimer (Sender: TObject);  // 10 Hz
begin
  TbxCurrentTime.text:= MyTime_hms;
  SendAndReceiveMessage;
end;

procedure TFrmMain.FormDestroy (Sender: TObject);
begin
  StopTalking;
end;

procedure TFrmMain.FormCreate (Sender: TObject);
begin
  // prevent problems regarding locale with ',' as decimal separator
  // so logfiles can be in comma separated format
  DefaultFormatSettings.DecimalSeparator:= '.';
  ExeDir:= Application.Location;
  Caption:= TITLE + VERSIONSTRING;
  ParameterFileName:= ExeDir + 'Parameters.txt';
  ReadParametersFromFile;
  NewLogFileNames;
  TbxArduinoIP.text:= ARDUINOIP;
  Compass:= tCompass.create;
  Persistence:= true;
end;

end.

